Index: admin_templates/incs/form_blocks.tpl
===================================================================
--- admin_templates/incs/form_blocks.tpl	(revision 14319)
+++ admin_templates/incs/form_blocks.tpl	(working copy)
@@ -270,6 +270,11 @@
 			<input type="hidden" name="<inp2:{$prefix}_InputName field='$field'/>[tmp_names]" id="<inp2:{$prefix}_InputName field='$field'/>[tmp_names]" value="">
 			<input type="hidden" name="<inp2:{$prefix}_InputName field='$field'/>[tmp_deleted]" id="<inp2:{$prefix}_InputName field='$field'/>[tmp_deleted]" value="">
 
+			<inp2:m_if check="{$prefix}_FieldOption" field="$field" option="description_field">
+				<inp2:$prefix_FieldOption field="$field" option="description_field" result_to_var="description_field"/>
+				<inp2:m_RenderElement name="inp_edit_hidden" prefix="$prefix" field="$description_field"/>
+			</inp2:m_if>
+
 			<script type="text/javascript">
 				UploadsManager.AddUploader('<inp2:{$prefix}_InputName field="$field"/>',
 					{
@@ -284,6 +289,7 @@
 						urls : '<inp2:{$prefix}_Field field="$field" format="file_urls" js_escape="1"/>',
 						names : '<inp2:{$prefix}_Field field="$field" format="file_names" js_escape="1"/>',
 						sizes : '<inp2:{$prefix}_Field field="$field" format="file_sizes" js_escape="1"/>',
+						description_field: '<inp2:$prefix_FieldOption field="$field" option="description_field"/>',
 						flashsid : '<inp2:m_SID/>',
 						uploadURL : '<inp2:m_t pass="all,$prefix" {$prefix}_event="OnUploadFile" js_escape="1" no_amp="1" />',
 						deleteURL : '<inp2:m_t pass="all,$prefix" {$prefix}_event="OnDeleteFile" field="#FIELD#" file="#FILE#" js_escape="1" no_amp="1"/>',
Index: admin_templates/js/uploader/uploader.js
===================================================================
--- admin_templates/js/uploader/uploader.js	(revision 14318)
+++ admin_templates/js/uploader/uploader.js	(working copy)
@@ -58,7 +58,8 @@
 		buttonDisabled : true, //false,
 		buttonCursor : -1, // ARROW : -1, HAND : -2
 		wmode : 'transparent', // "window", "transparent", "opaque"
-		buttonPlaceholderId: false
+		buttonPlaceholderId: false,
+		description_field: ''
 	}
 
 	for (var $param_name in $defaults) {
@@ -100,6 +101,30 @@
 	document.getElementById(this.id+'[tmp_deleted]').value = this.deleted.join('|');
 }
 
+Uploader.prototype._prepareDescriptions = function() {
+	var $ret = '';
+
+	if (!this.params.description_field) {
+		return ;
+	}
+
+	for (var f = 0; f < this.files.length; f++) {
+		if ( !isset(this.files[f].uploaded) ) {
+			continue;
+		}
+
+		$ret += document.getElementById(this.files[f].id + '_description').value + '|'
+	}
+
+	this._getDescriptions().value = $ret.replace(/\|$/, '');
+}
+
+Uploader.prototype._getDescriptions = function () {
+	var $descriptions_id = this.id.replace(this.params.field, this.params.description_field);
+
+	return document.getElementById($descriptions_id);
+}
+
 Uploader.prototype._formatSize = function (bytes) {
 	var kb = Math.round(bytes / 1024);
 
@@ -278,12 +303,20 @@
 	return this.IconPath + '/' + $icon + '.gif';
 }
 
-Uploader.prototype.getQueueElement = function($file) {
+Uploader.prototype.getQueueElement = function($file, $file_index) {
 	var $ret = '';
 	var $icon_image = this.getFileIcon($file.name);
 	var $file_label = $file.name + ' (' + this._formatSize($file.size) + ')';
 	var $need_preview = false;
 
+	if (this.params.description_field) {
+		var $descriptions = this._getDescriptions().value;
+
+		if ($descriptions.length > 0) {
+			$descriptions = $descriptions.split('|');
+		}
+	}
+
 	if (isset($file.uploaded)) {
 		// add deletion checkbox
 		$need_preview = (this.params.thumb_format.length > 0) && this.isImage($file.name);
@@ -301,8 +334,15 @@
 
 		$ret += '</div>'
 
+		if (this.params.description_field) {
+			var $description_input = '<div style="margin-top: 5px;"><input type="text" class="description-input" id="' + $file.id + '_description" value="" style="width: 300px;"/></div>';
+		}
+		else {
+			var $description_input = '';
+		}
+
 		// add filename + preview link
-		$ret += '<div class="left file-label"><a href="' + $file.url + '" target="_new">' + $file_label + '</a></div>';
+		$ret += '<div class="left file-label"><a href="' + $file.url + '" target="_new">' + $file_label + '</a>' + $description_input + '</div>';
 	}
 	else {
 		// add icon based on file type
@@ -337,6 +377,16 @@
 		}
 	);
 
+	if (this.params.description_field) {
+		$('.description-input', $ret)
+		.val( $file_index < $descriptions.length ? $descriptions[$file_index] : '' )
+		.change(
+			function ($e) {
+				$me._prepareDescriptions();
+			}
+		);
+	}
+
 	// prepare auto-loading preview
 	var $image = $('img.thumbnail-image', $ret);
 
@@ -366,7 +416,7 @@
 		return ;
 	}
 
-	$ret = this.getQueueElement( this.files[$file_index] );
+	$ret = this.getQueueElement( this.files[$file_index], $file_index );
 	var $row = $( jq('#' + this.files[$file_index].id + '_queue_row') );
 
 	if ($row.length > 0) {
@@ -393,6 +443,7 @@
 	}
 
 	this._prepareFiles();
+	this._prepareDescriptions();
 }
 
 Uploader.prototype.updateProgressOnly = function ($file_index) {
